; Directory Listing Module for Expander2 TI-92 Driver
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/


list_dir:
;        clr.l value
        bsr ClearMenu
	move.w #$C,d0		; Folder table
	handle_ptr d0,a0	; a0 now holds addr to VAT
	move.l a0,vataddr
        move.w 2(a0),filenum         ; Number of entries now in filenum
;        move.w d0,value+2
;        move.w d0,filenum
	move.w #1,count
;	move.w #1,pcount
        addq.l #$04,vataddr
        move.l vataddr,vattemp
	move.w #20,row
        bsr PutPaused

dir_loop:
;        clr.l value
;	move.w count,value+2
;	bsr PrintVal
;	WriteStr #1,#1,#4,buffer
;	move.w #$0C,d0
;	handle_ptr d0,a0	; a0 now holds addr to VAT
;	move.w 2(a0),d0		; Number of entries now in filenum
	move.w filenum,d0
	move.w count,d1
        subq.w #1,d1
	cmp.w d0,d1
	beq exit_dir
        cmp.w #0,d1
        beq pagin_resume
	move.w d1,d2
        divu #8,d1              ; Test to see if multiple of 8
        mulu #8,d1
	cmp.w d1,d2
	beq paginator
pagin_resume:
	move.w #1,pcount
	bsr disp_loop	
	add.l #$0C,vataddr
	move.l vataddr,vattemp
	add.w #10,row
        addq.w #1,count
;	jsr flib[idle_loop]
;	cmp.w #264,d0
;	beq exit_dir
	bra dir_loop

paginator:
;	clr.w value
;        move.w filenum,value+2
;        bsr PrintVal            ; Convert to string
;        add.w #10,row
;        WriteStr #10,row,#4,filenm
;        WriteStr #170,row,#4,buffer
;        add.w #15,row
        bsr wait_key
	cmp.w #264,d0
	beq exit_now
        move.w #20,row
;	move.w #1,count
        bsr ClearMenu
;        bsr PutPaused
	bra pagin_resume

disp_loop:
	cmp.w #9,pcount		; Only print 8 chars
	beq disp_type
;	WriteStr #50,#50,#4,filenm
	move.l vattemp,a0
	move.b (a0),d0
	cmp.w #0,d0
	beq disp_type
;        clr.l value
;	bsr PrintVal
	move.w pcount,d1
	mulu #6,d1
        add.w #12,d1
	move.b (a0),value+3
	WriteChar d1,row,value+2
        addq.w #1,pcount
        addq.l #1,vattemp
	bra disp_loop

disp_type:
	move.l vataddr,a0
	adda #$0A,a0		; Offset for handle of the file
	move.w (a0),d0		; d0 has handle of the file
	handle_ptr d0,a0	; a0 now has addr to file
        move.l a0,vatemp        ; Other vat temp variable
	move.w (a0),d0		; Move file size into d0
        addq.l #1,d0             ; Add 1 to file size - Type byte
	adda d0,a0		; Add this to addr - Getting a0 is now
	move.b (a0),d1		; d1 is now type byte. See files.txt
	cmp.w #$DC,d1		; Compare to program
	beq file_prgm
	cmp.w #$E0,d1		; Text type
	beq file_text
	cmp.w #$2D,d1		; String type
	beq file_stng
	cmp.w #$DF,d1		; Picture type
	beq file_pict
	WriteStr #100,row,#4,unkn	; Unknown type, so display
	bra file_size

file_prgm:
	WriteStr #100,row,#4,prgm
	bra file_size

file_text:
	WriteStr #100,row,#4,txt
	bra file_size

file_stng:
	WriteStr #100,row,#4,stng
	bra file_size

file_pict:
	WriteStr #100,row,#4,pict
	
file_size:
        move.l vatemp,a0
	move.w (a0),value+2	; Move length of file into value
        addq.l #2,value          ; We need to add 2 to get file size
	bsr PrintVal		; Convert to string
        WriteStr #180,row,#4,buffer
	rts

exit_dir:
;        move.w filenum,value+2
;        bsr PrintVal            ; Convert to string
;        add.w #10,row
;        WriteStr #10,row,#4,filenm
;        WriteStr #170,row,#4,buffer
;        add.w #15,row
;       WriteStr #100,row,#2,pause
;        bsr PutPaused
        bsr wait_key
exit_now:
        bsr ClearMenu
	bsr PutReady
        bsr PutMenu
	bra main_loop

PrintVal:
        move.l value(PC),-(a7)  ; Push VALUE
        pea format(PC)          ; Push format to stack
        pea buffer(PC)          ; Push buffer addr
        jsr tios::sprintf       ; Convert
        lea 12(a7),a7           ; Change stack
        rts
