; String input module for TI-92 Expander2 Driver
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/
;
; Input routine for Expander2 -- Gets the handle of file wanted.
; col,row - First spot to print letter
; addr -- Address to store 8 character input at
;
get_fname:
        lea filenm(PC),a0               ; & store in temp_addr
        move.l a0,table_temp             ; Get address of buffer var
;        move.w #0,count
;        move.w #0,charpnt               ; Which character are we on?
        move.w #120,col
        move.w #50,row
        WriteStr #10,#50,#4,gfn
;zero_var:
;        cmp.w #8,count
;        beq get_char
;        move.l table_temp,a0
;        add.w count,a0
;        move.b #0,(a0)                  ; Zero out that byte
;        addq.w #1,count
;        bra zero_var
	move.l table_temp,a0		; Move buffer addr to a0
	move.l #0,(a0)+			; Set all of the characters to 0
	move.l #0,(a0)+			; Cleans up from last input
get_char:
        move.w #0,count
        WriteChar col,row,#16           ; "Cursor"
get_char2:
        bsr wait_key                    ; no APD!!
        move.w d0,key
        cmp.w #257,key                  ; Is this a backspace?
        beq got_bs
        cmp.w #13,key                   ; Or an enter?
        beq got_cr                      ;
        cmp.w #32,key                   ; Can't have spaces in file names
        beq get_char2
        cmp.w #264,key
        beq stop_inp                    ; Forget file send
        cmp.w #8,count
        beq get_char2
        WriteChar col,row,key           ; Display the keypress
        move.l table_temp,a0
        add.w count,a0                  ; Get the right offset
        move.b key+1,(a0)               ; Load key with LSByte
        addq.w #1,count
        addq.w #6,col
        WriteChar col,row,#16           ; "Cursor"
        bra get_char2
got_bs:
        cmp.w #0,count
        beq get_char2
        WriteChar col,row,#32           ; Space out old cursor
        subq.w #1,count                 ; Move back a byte
        subq.w #6,col
        move.l table_temp,a0            ; Zero out that character
        add.w count,a0
        move.b #0,(a0)
        WriteChar col,row,#16         ; Erase that character
        bra get_char2
got_cr:
        cmp.w #0,count
        beq get_char2
	bsr check_for_file
        cmp.w #0,f_handle                     ; Did we get a handle or not?
        beq no_mtch                     ; We didn't find the file
        bra ret_inp
stop_inp:
        move.w #1,d1                    ; Signal an abort
no_mtch:
;        WriteStr #10,#70,#4,fnf         ; file not found
        move.w #0,d0
ret_inp:
;        bsr wait_key                    ; Wait for a keypress
        rts

; Check to see if file exists in VAT... if it does, abort.
; Damned Ellsworth took this out of the ROM
check_for_file:
	move.w #$C,d0		; Folder table
	handle_ptr d0,a0	; a0 now holds addr to VAT
	move.l a0,vataddr
        move.w 2(a0),filenum    ; Number of entries now in filenum
	addq.l #4,vataddr
        move.l vataddr,vattemp
	move.w #1,count		; Setup counter

check_loop:
	move.w filenum,d0
	move.w count,d1
        subq.w #1,d1
	cmp.w d0,d1
	beq exit_check
	lea filenm(PC),a0
	move.l vataddr,a1
	bsr cmp_eight
	cmp.w #1,d0
	beq get_handle
        add.l #$C,vataddr
	addq.w #1,count
	bra check_loop

exit_check:
	move.w #0,f_handle
	rts

get_handle:
        add.l #$A,vataddr     ; See files2.txt
	move.l vataddr,a0	; Get handle, and return
	move.w (a0),f_handle
	rts
