; E2 Listing Module for TI-92 Expander2 Driver
; Written by Bryan Rittmeyer <bryanr@pair.com>
; Copyright (C) 1997-1999 Horizon Technologies
; http://horizon.pair.com/
;
; Lists files on Expander2
; Not very modular but it more or less works ;-)
; Uses a cute algo that calculates where the next file will be
; Avoids having to scan each page, which was extremely slow with large
; files. Tested to work.
list_eup:
        bsr ClearMenu                   ; Clear out menu display
        move.w #0,page
        move.w #20,row
        move.w #0,lcount
	move.l #0,totsize
        WriteStr #10,#100,#4,scand
        WriteStr #150,#100,#4,oftot
        bsr PutBusy
list_loop:
        cmp.w #2048,page
        beq exit_list                    ; We're done looking
        move.w #4,numba
        move.b #0,pstart
        lea buff2(PC),a0
        move.l a0,table_addr
        bsr get_sfe                       ; Get four bytes from that page
;        WriteStr #100,#100,#4,buff2      ; Make sure match routine works
        move.w page,value+2
        bsr PrintVal
        WriteStr #100,#100,#4,buffer
        cmp.b #$FF,buff2                ; Is the first byte of string FF?
        beq exit_list                   ; If it is, exit, no more files
;        lea buff2(PC),a0
;        lea secs(PC),a1                   ; code (EUPS) -- Old method of
;        bsr cmp_four				; ID... see file system info
;        cmp.w #1,d0                       ; This page contains file info
;        beq get_pfinfo                    ; Get page file info
;        addq.w #1,page                    ; Lets try the next page ;-)
;        bra list_loop

get_pfinfo:
        move.w lcount,d0
        cmp.w #0,d0
        beq pager_resume
        divu #7,d0
        mulu #7,d0
        cmp.w lcount,d0
        bne pager_resume
        bsr PutPaused
        bsr wait_key                    ; Wait for a key press
	cmp.w #264,d0			; Did the user hit escape?
	beq exit_now			; If so, exit now!
        bsr ClearFile                   ; Don't clear the status
        move.w #20,row
        bsr PutBusy
pager_resume:
        move.w #8,numba                 ; Get file name and place it in
        move.b #4,pstart                ; string "filenm"
        lea filenm(PC),a0
        move.l a0,table_addr
        bsr get_sfe
        WriteStr #10,row,#4,filenm      ; Output the file name
        move.w #1,numba                 ; Get file TYPE
        move.b #12,pstart               ; Type offset
        lea type(PC),a0
        move.l a0,table_addr
        bsr get_sfe
        cmp.b #00,type                  ; Program?
        beq prog_disp
        cmp.b #01,type
        beq text_disp                  ; String?
        cmp.b #02,type
        beq stng_disp
        cmp.b #03,type
        beq pict_disp
        WriteStr #100,row,#4,unkn       ; Unknown type
        bra get_size
prog_disp:
        WriteStr #100,row,#4,prgm
        bra get_size
text_disp:
        WriteStr #100,row,#4,txt
        bra get_size
stng_disp:
        WriteStr #100,row,#4,stng
        bra get_size
pict_disp:
        WriteStr #100,row,#4,pict
get_size:
        move.w #2,numba
        move.b #13,pstart
        lea size(PC),a0
        move.l a0,table_addr
        bsr get_sfe
        move.w size,value+2           ; Copy file size to value for display
        addq.w #2,value+2               ; Make it display same as Var-Link
	clr.l d0
	move.w value+2,d0
	add.l d0,totsize		; Add value to total size
        bsr PrintVal
        WriteStr #180,row,#4,buffer     ; Display file size
        move.w size,d0                  ; Put file size into d0
        cmp.w #249,d0                   ; Is file one page? if so, go to next page
        ble next_page
        sub.w #249,d0                   ; Subtract number of bytes on this page
        move.w d0,d2
        divu #260,d0                    ; Divide file size by 260
        move.w d0,d1
        mulu #260,d1                    ; Test to see if division was even
        cmp.w d1,d2                     ; If so, d1=d2
        beq add_itnow
        addq.w #1,page
add_itnow:
        add.w d0,page                   ; Advance search pointer that many pages
next_page:
        addq.w #1,page                  ; Set us up for next page
        add.w #10,row
        addq.w #1,lcount
        bra list_loop                   ; Go back and look for more files

exit_list:
        bsr PutPaused
        cmp.w #0,lcount                 ; Did we get any files?
        bne exit_shtot
        WriteStr #10,#30,#4,noff
        bra exit_dir

exit_shtot:
	move.l totsize,value
	bsr PrintVal
	add.w #20,row
	WriteStr #10,row,#4,buffer
	WriteStr #75,row,#4,oftot2
	clr.l value
	bra exit_dir

; a0 - First string to compare
; a1 - Second string to compare
; Return: d0=0 (no match) d0=1 (match)
;cmp_four:
;        move.l #3,d1
;cmp_loop:
;        cmp.b (a0)+,(a1)+
;        bne not_eq
;        dbra d1,cmp_loop
;        move.w #1,d0
;        rts
;not_eq:
;        move.w #0,d0
;        rts

; Used to see if two filenames are identical
cmp_eight:
        move.l #7,d1
cmp_loop2:
        cmp.b (a0)+,(a1)+
        bne not_eq2
        dbra d1,cmp_loop2
        move.w #1,d0
        rts
not_eq2:
        move.w #0,d0
        rts
